/*
  Copyright		(c)2011 Paolo Lavacchini (All rights reserved)
  Date:         8/2/2011
  Projet name: 	LAB 
  Site          www.lsoft.it
  Contact:      p.lavacchini@tin.it
  Subject:      open source for Arduino L_soft Arduino Basic
  Status:		Preliminary
  Version:		0.1 (10/03/2011)

  Modified:		none
  Conributors:	none

  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or 
  (at your option) any later version. 

  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
  GNU General Public License for more details. 

  You should have received a copy of the GNU General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/>. 

*/




#include "LAB_Def.h"




#ifdef DEBUG_ON  //===== Pc enviroment =======================



void A_Board_Init (void)
{
	return;
}




int A_printf (char *fmt,...)
{
va_list  argptr;
char str[64];
int cnt,i;

	va_start( argptr, fmt );
	cnt = vsprintf( str, fmt, argptr );
	i=0; while ( str[i] ) putchar(str[i++]);
	va_end( argptr );
	return( cnt );
}



void A_putc (char chr)
{
	putchar(chr);
}




int A_getch (void)
{

	return getch();
}



int A_sense_char (void)
{
char sense;

	if ( !kbhit() ) return -1;
	sense = (char)(getch());
	ungetch(sense);
	return sense;

}



clock_t A_clock (void)
{
	return (clock());  
}


unsigned char debug_var[65536];
void Set_Reg_AVR (int reg,unsigned char value)
{
  debug_var[reg]=value;
}



unsigned char Get_Reg_AVR (int reg)
{
  return( debug_var[reg]);
}




void Delay_1mS (void)
{
clock_t iclock;

   iclock = (CLOCKS_PER_SEC/1000) + clock();
   while ( iclock > clock() );
}




void Save (void)
{	
FILE *fini;
	
	if ( Mem_size <= 0 || Mem_size > MAX_E2PROM )
			{ A_printf("Invalid program\n");  return; }

	if ( fini = fopen("EEPROM.BIN","wb") )
	{
		fwrite(&Auto_Run,sizeof(Auto_Run),1,fini);
		fwrite(&Mem_size,sizeof(Mem_size),1,fini);
		fwrite(&Program,Mem_size+1,1,fini);
		fclose(fini);
	}
		else A_printf("Can't open file\n");
	return;

}

void Load (void)
{
FILE *fini;
	
	if ( fini = fopen("EEPROM.BIN","rb") )
	{
		fread(&Auto_Run,sizeof(Auto_Run),1,fini);
		fread(&Mem_size,sizeof(Mem_size),1,fini);
		if ( Mem_size <= 0 || Mem_size > MAX_E2PROM )
			{ A_printf("Invalid program\n"); fclose(fini); return; }

		fread(&Program,Mem_size+1,1,fini);
		fclose(fini);
	}
		else A_printf("Can't open file\n");
	return;

}

char Get_Auto_Run (void)
{
	return 0;
}


#endif

