/*
  Copyright		(c)2011 Paolo Lavacchini (All rights reserved)
  Date:         8/2/2011
  Projet name: 	LAB 
  Site          www.lsoft.it
  Contact:      p.lavacchini@tin.it
  Subject:      open source for Arduino L_soft Arduino Basic
  Status:		Preliminary
  Version:		0.1 (10/03/2011)

  Modified:		none
  Conributors:	none

  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or 
  (at your option) any later version. 

  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
  GNU General Public License for more details. 

  You should have received a copy of the GNU General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/>. 

*/



#include "LAB_Def.h"







char *Get_expression (char *line, long *value)
{
long v1,v2;
char op;
static char *xp;

	if ( Recurse >= MAX_RECURSE ) 
		{ A_printf ("Max expression limit\n"); Recurse--; *value=-1L; return xp; }

	Recurse++;
	xp = line; 
	xp = Skip_Blank(xp);

	if ( *xp == '(' )
	{
	xp++; 
	xp = Skip_Blank(xp); 
	xp = Get_expression( xp,&v1 );
	if ( !(*xp) ) { Recurse--; *value=(long)(v1&0xffff); return xp; }
	if ( *xp == ')' ) { xp++; Recurse--; *value=(long)(v1&0xffff); return xp; }
	}
	
	xp = Get_value( xp, &v1 ); 
	if ( v1 == -1L ) { Recurse--; *value=-1L; return xp; }

	xp = Skip_Blank(xp); 

	if ( !(*xp) ) { Recurse--; *value=(long)(v1&0xffff); return (xp); }

	if ( *xp == ')')
	{
	xp++;
	xp = Skip_Blank(xp); 
	*value = (long)(v1&0xffff);
	Recurse--;
	return (xp);
	}

	op = *xp;

	if ((op != '+' )&&(op != '-' )&&(op != '*' )&&(op != '/' )&&
		(op != '%' )&&(op != '&' )&&(op != '^' )&&(op != '|' )&&
		(op != '<' )&&(op != '>' ) ) { Recurse--; *value=-1L; return xp; }

	xp++; 
	xp = Skip_Blank(xp); 

	xp = Get_expression(xp,&v2 );
	
	if ( v2 == -1L ) { Recurse--; *value=-1L; return xp; }


	switch(op)
	{
	case('+'): v1 = v1 + v2; break;
	case('-'): v1 = v1 - v2; break;
	case('*'): v1 = v1 * v2; break;
	case('&'): v1 = v1 & v2; break;
	case('|'): v1 = v1 | v2; break;
	case('^'): v1 = v1 ^ v2; break;
	case('<'): v1 = v1 < v2; break;
	case('>'): v1 = v1 > v2; break;
	case('/'): 
	case('%'): 
	if ( !v2 ) { A_printf("Division by zero\n"); Recurse--; *value=-1L; return xp; } 
		else if ( op == '/' ) v1 = v1 / v2; else v1 = v1 % v2; break;
	}

	*value=(long)(v1&0xffff);
	Recurse--;
	return(xp);

}





int Load_variable (char *line)
{
long tv,pv,xx,rr;

	line = Skip_Blank(line);

	if ( *line == '@') // Vettore?
	{
	line++;
	line = Skip_Blank(line);
	if ( *line != '[' ) return 0;
	line++; /* Skip [ */
	line = Get_expression(line,&pv);
	if ( pv > MAX_IDX ) return 0;
	
	while (( *line != ']' )&&( *line != 0 )) line++;
	
	if ( *line != ']' ) return 0;

	line++;
	line = Skip_Blank(line);
	
	if ( *line != '=' ) return 0;
	line++;
	line = Skip_Blank(line);

	line = Get_expression(line,&xx);
	if ( xx == -1 ) return 0;
	 else
		{
		line=Get_expression(line,&xx);
		Vettore_index[pv] = xx;
		}
	 return -1;
	 }

	if ( *line == '.')
	{
	line = Skip_Blank(line); // lasciare il punto
	line = Get_Register(line,&rr);
	if ( rr == -1L ) return -1;

	if ( *line != '=' ) return 0;
	line++;
	line = Skip_Blank(line);

	line = Get_expression(line,&tv);
	
	if ( tv == -1L ) return 0;

	Set_Reg_AVR((int)rr,(unsigned char)tv);

	return -1;
	}


	pv = *line - 'A'; // Variabile
	line++;
	line = Skip_Blank(line);

	if ( *line != '=' ) return 0;
	line++;
	line = Skip_Blank(line);

	line = Get_expression(line,&tv);
	
	if ( tv == -1L ) return 0;

	else Vettore_variabili[pv] = (int)(tv);

	return -1;
}





int Set_variable (char*line,int val)
{
long pv;

	line = Skip_Blank(line);
	
	if ( *line == '@')
	 {
	 line++;
	 line = Skip_Blank(line);
	 if ( *line != '[' ) return 0;
	 line++; /* Skip [ */
	 line = Get_expression(line,&pv);
	 if ( pv > MAX_IDX ) return 0;
	 while (( *line != ']' )&&( *line != 0 )) line++;
	 if ( *line != ']' ) return 0;
	 else Vettore_index[pv] = val;
	 return -1;
	 }

	if ( *line == '.')
	{
	line = Skip_Blank(line);
	line = Get_Register(line,&pv);
	Set_Reg_AVR(pv,(unsigned char)(val));
	return -1;
	}

	pv = *line - 'A';
	Vettore_variabili[pv] = val;

	return -1;
}








char *Get_variable (char *line,long *variable)
{
long vp,retv;

	line = Skip_Blank(line);

	if ( *line == '@')
	{
	line++;
	line = Skip_Blank(line);
	line++; /* Skip [ */
	line = Get_expression(line,&vp);
	while (( *line != ']' )&&( *line != 0 )) line++;
	if ( *line == ']' ) line++;
	*variable = (Vettore_index[vp]&0xffff);
	return line;
	}

	if ( *line == '.')
	{
	line = Skip_Blank(line); // lasciare il punto
	line = Get_Register(line,&vp);
	retv = Get_Reg_AVR(vp);
	*variable = retv;
	return line;
	}

 
 
	*variable = (long)(Vettore_variabili[*line - 'A']&0xffff);
	line++;
	
	return line;
}






// Riporta l'address di un registro o errore -1
char *Get_Register (char *line, long *address)
{
long ladd;

	line = Skip_Blank(line);
	line++;
	line = Get_number (line,&ladd);
	*address=(long)(ladd&0xffff);
	return line;

}




