/*
  Copyright		(c)2011 Paolo Lavacchini (All rights reserved)
  Date:         8/2/2011
  Projet name: 	LAB 
  Site          www.lsoft.it
  Contact:      p.lavacchini@tin.it
  Subject:      open source for Arduino L_soft Arduino Basic
  Status:		Preliminary
  Version:		0.1 (10/03/2011)

  Modified:		none
  Conributors:	none

  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or 
  (at your option) any later version. 

  This program is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
  GNU General Public License for more details. 

  You should have received a copy of the GNU General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/>. 

*/





#include "LAB_Def.h"







int Get_Edit_Line (char edit,char *line)
{
int lp,mp,bcnt;
char *tp,c;


	bcnt=0;

	if ( edit )
	{
	mp = Get_Line_Pnt(atol(line));
	if ( mp < 0 || mp > MAX_LINE) { A_printf("\nWrong line\n"); return(0); }
	strcpy(Line,&Program[mp]);
	}

	lp = 0;
	tp = line;
	if ( edit )
	{ A_printf("\n%s",Line); lp=strlen(Line); tp=Line+strlen(Line); }
	else
	A_printf ("> ");

	while (1)
	{
	c = (char)A_getch();
	if ( c == TAB ) c = SPACE;
 

	switch (c)
	{
	case CTRL_R:
	if ( !lp && strlen(Line) ) 
	{
	strcpy(line,Line);
	A_printf("%s",line);
	lp=strlen(Line);
	tp = (char*)line+lp;
	}
	break;

	case ESC_CHAR:
	*line=0;
	A_printf("<Break>\n");
	return 0;

	case CR:
	if ( !edit ) *tp = 0;
	A_printf("\n");
	if ( edit ) Insert_Line(Line);
	if ( !strlen(line) ) return (0); else return (1);

	case CTRL_B: 
	if ( lp > 0 && bcnt < lp ) { A_printf("%c",8); bcnt++; tp--; /*lp--;*/ }
	break;

	case CTRL_N: 
	if ( bcnt) { A_printf("%c",line[strlen(line)-bcnt]); bcnt--; tp--; /*lp--;*/ }
	break;

	case BACKSPACE:
	if ( bcnt) 
	{ 
		A_printf("%c%c",8,line[strlen(line)-bcnt+1]); 
		memmove(&line[strlen(line)-bcnt+1],&line[strlen(line)-bcnt+2],strlen(line)-1 );
		tp--;
	}
	else 
		if ( lp > 0) { A_printf("%c%c%c",8,0x20,8); tp--; lp--; }
	
	break;

	default:
	A_printf ("%c",c);
	if ( !lp && c == SPACE) break;
	if ( edit && bcnt ) 
	{
	line[strlen(line)-bcnt]=c;
	bcnt--;
	}
	else
	{
	*tp = (char)(c);
	tp++;
	lp++;
	}
	break;

	}

	if ( lp > MAX_LIN_LEN) { A_printf("\nLine too long\n"); return(0); }
	}

	return 0;
}






int Field_input ( char *l )
{
char lbuffer[MAX_FLD_LEN],*bp;
int i;
long v;

	l = Skip_Blank(l);
	if ( Test_Variable(l) )
	{

	for(i=0; i<MAX_FLD_LEN; i++)
	{
		lbuffer[i]=toupper((char)(A_getch()));
		if ( lbuffer[i] == ESC_CHAR ) return -2;
		if ( lbuffer[i] == CR ) break;
	}

	if ( i == MAX_FLD_LEN ) return -1;

    bp = &lbuffer[0];
    bp = Get_value(bp,&v);

    if ( ( v != -1L ) && Set_variable(l,(int)(v)) ) return 0;
    }

	return -1;
}




